#include "StdAfx.h"
#include "Globals.h"

int g_separatorComma;

InputError handleInputError( int errorCode )
{
	InputError inputError;
	inputError.errorCode = errorCode;
	
	switch( errorCode )
	{
		case INPUT_ERROR_COLUMN:
			inputError.errorString = _T( "Invalid column number" );
			break;
		case INPUT_ERROR_COLUMN_REFERENCE:
			inputError.errorString = _T( "Invalid column number in column reference" );
			break;
		case INPUT_ERROR_COLUMN_DV:
			inputError.errorString = _T( "Invalid column number in column # DV" );
			break;
		case INPUT_ERROR_LINE_FROM:
			inputError.errorString = _T( "Invalid line number in 'line from'" );
			break;
		case INPUT_ERROR_LINE_TO:
			inputError.errorString = _T( "Invalid line number in 'line to'" );
			break;
		case INPUT_ERROR_SPECIAL_DV:
			inputError.errorString = _T( "Invalid column number in special DV" );
			break;
		case INPUT_ERROR_TEXTREF_EQUAL_SIGN:
			inputError.errorString = _T( "'Equal sign' is not defined in 'as test' mode" );
			break;
		case INPUT_ERROR_TEXTREF_UNEQUAL_SIGN:
			inputError.errorString = _T( "'Unequal sign' is not defined in 'as test' mode" );
			break;
	}

	return inputError;
}