#include "StdAfx.h"
#include ".\avgridctrl.h"

AVGridCtrl::AVGridCtrl(void)
{
}

AVGridCtrl::~AVGridCtrl(void)
{
}

UINT AVGridCtrl::GetItemState(int nRow, int nCol) const
{
	if ( (nRow >= 0) && (nCol >= 0) )
	{
		CGridCellBase* pCell = GetCell(nRow, nCol);
		ASSERT(pCell);
		if (!pCell)
			return 0;

		return pCell->GetState();
	}
	else
		return 0;
}

void AVGridCtrl::setGridCellColor(int row, int column, int r, int g, int b)
{
	CGridDefaultCell *theCell = (CGridDefaultCell*) GetCell(row, column);
	theCell->SetBackClr(RGB(r, g, b));

	int red = GetRValue(theCell->GetBackClr());
	int green = GetGValue(theCell->GetBackClr());
	int blue = GetBValue(theCell->GetBackClr());
	
}

void AVGridCtrl::setGridRowColor(int row, int r, int g, int b)
{
	for (int i=0; i < GetColumnCount(); i++)
	{
		setGridCellColor( row, i, r, g, b );
	}
}

void AVGridCtrl::setGridRowPink(int row, int type)
{
	if (type == 1)
		setGridRowColor( row, 240, 200, 210 );
	else
		setGridRowColor( row, 240, 150, 160 );
}

int AVGridCtrl::getGridRowColorType( int row )
{
	CGridDefaultCell *theCell = (CGridDefaultCell*) GetCell(row, 0);

	int red = GetRValue(theCell->GetBackClr());
	int green = GetGValue(theCell->GetBackClr());
	int blue = GetBValue(theCell->GetBackClr());

	if ( (red == 255) && (green == 255) && (blue == 255) )
		return 0;
	
	if ( (red == 240) && (green == 200) && (blue == 210) )
		return 1;
	else
		return 2;
}

void AVGridCtrl::setGridRowWhite(int row)
{
	setGridRowColor( row, 255, 255, 255 );
}

void AVGridCtrl::setGridCellComparator(int line, int column, BOOL setToEquals)
{
	if (!SetCellType(line, column, RUNTIME_CLASS(CGridCellCombo)))
        return;

    if (setToEquals)
		SetItemText(line, column, _T("="));

    CStringArray options;
    options.Add(_T("<"));
    options.Add(_T("<="));
    options.Add(_T("="));
	options.Add(_T("<>"));
	options.Add(_T(">="));
	options.Add(_T(">"));
	options.Add(_T("equal sign"));
	options.Add(_T("unequal sign"));

	SetColumnWidth(1, 100); 

    CGridCellCombo *pCell1 = (CGridCellCombo*) GetCell(line, column);
    pCell1->SetOptions(options);
    pCell1->SetStyle(CBS_DROPDOWN); //CBS_DROPDOWN, CBS_DROPDOWNLIST, CBS_SIMPLE
}

void AVGridCtrl::setGridCellReferenceMenu( int line, int column )
{
	if (!SetCellType(line, column, RUNTIME_CLASS(CGridCellCombo)))
        return;

	SetItemText(line, column, _T("constant"));

	CStringArray options;
    options.Add(_T("constant"));
	options.Add(_T("column #"));

	CGridCellCombo *pCell1 = (CGridCellCombo*) GetCell(line, column);
    pCell1->SetOptions(options);
    pCell1->SetStyle(CBS_DROPDOWN); //CBS_DROPDOWN, CBS_DROPDOWNLIST, CBS_SIMPLE
}

void AVGridCtrl::setGridCellCheckBox(int line, int column)
{
	if (!SetCellType(line, column, RUNTIME_CLASS(CGridCellCombo)))
        return;

	SetCellType(line, column, RUNTIME_CLASS(CGridCellCheck));
}

BOOL AVGridCtrl::returnGridCheck(int row, int column)
{
	BOOL result = FALSE;
	CGridCellCheck *pCell = (CGridCellCheck*) GetCell( row, column );
	result = pCell->GetCheck();
	
	return result;
}

void AVGridCtrl::setGridCheck(int row, int column, BOOL state)
{
	CGridCellCheck *pCell = (CGridCellCheck*) GetCell( row, column );
	pCell->SetCheck( state );	
}

BOOL AVGridCtrl::SetRowCount( int nRows )
{
	BOOL result = CGridCtrl::SetRowCount( nRows );

	// Sonst kracht es bei Einfgen der CheckBox in nicht vorhandene Spalte
	if (GetColumnCount() < 5)
		SetColumnCount( 5 );

	if( nRows < 2 )
		return result;
	
	for (int i=1; i < nRows; i++)
	{
		setGridCellComparator( i, 1 );
		setGridCellReferenceMenu( i, 3 );
		setGridCellCheckBox( i, 4 );
	}

	CGridCellCheck *pCell = (CGridCellCheck*) GetCell( 1, 3 );
	pCell->SetCheck( FALSE );

	return result;
}
